/*
 * An implementation of Mobile-IP as described in RFC 2002.
 * Author: Vipul Gupta (vgupta@eng.sun.com)
 * mnID.c : Routines to manipulate 64-bits IDs used for replay protection.
 */

#pragma ident	"@(#)mnID.c 1.1 97/10/01"

#include "mip.h"
#include "mobile.h"

extern int IDfreshnessSlack;
extern u32 randomLong();
extern u32 CurrentTimeNTPSec();

void MNnewID(u32 *newIDHigh, u32 *newIDLow, u32 IDHigh, 
	     u32 IDLow, int ReplayStyle, int timeSkew)
{
    if (ReplayStyle == NONCES) {	
	*newIDHigh = IDHigh;
    } else if (ReplayStyle == TIMESTAMPS)  {
        *newIDHigh = CurrentTimeNTPSec() + timeSkew;
    } else  {
        *newIDHigh = 0;
    }
    *newIDLow = randomLong();
}

void MNstoreID(u32 *StoredIDHigh, u32 *StoredIDLow, u32 IDHigh, 
	       u32 IDLow, int ReplayStyle, int *timeSkew)
{
   if (ReplayStyle == NONCES) 
        *StoredIDHigh = IDHigh;
   else if (ReplayStyle == TIMESTAMPS)
        *timeSkew = IDHigh - CurrentTimeNTPSec();
}

